
#define	_CRT_SECURE_NO_WARNINGS	//	scanfԼ  ؼ 
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <stdlib.h>
#include "Queue.h"	//	ť   

#define			YES			1
#define			NO			0

int		g_maxPalindromStrLen;	//	Է ڿ κ ڿ ִ ȸ Ǵ 
char*	g_pPalindromStr;		//	Է ڿ κ ڿ ִ ȸ Ǵ ڿ 

int		g_DT[64][64];			//	Ž , ߺ κ ŽϷ   ̿  Ž     

/*
	PalindromeByBFSԼ Է¹ ڿ ȸ Žϴ Լ
	 Ű Ž ġ ε δ.
	ȸ  ⺻ Ž   ġ ڿ   ġ ڿ 񱳸  ȴ.
*/
void PalindromeByBFS(int startIdx, int endIdx, char* pStr);

int main(void)
{
	char str[512] = { 0, };

	printf("Է => ");
	scanf("%s", str);

	int len = strlen(str);
	
	g_pPalindromStr = (char*)malloc(sizeof(char) * (len + 1));

	memset(g_pPalindromStr,0,len + 1);

	PalindromeByBFS(0,len - 1, str);

	printf("%s\n", g_pPalindromStr);

	printf(" : %d\n", g_maxPalindromStrLen);

	if (g_pPalindromStr != NULL)
		free(g_pPalindromStr);

	return 0;
}

/*
	PalindromeByBFSԼ Է¹ ڿ ȸ Žϴ Լ
	 Ű Ž ġ ε δ.
	ȸ  ⺻ Ž   ġ ڿ   ġ ڿ 񱳸  ȴ.
*/
void PalindromeByBFS(int startIdx, int endIdx, char* pStr)
{
	Index searchIdx = {startIdx, endIdx};

	Queue q;						//	ť 
		
	QueueInit(&q);					//	ť ʱȭ

	Push(&q, searchIdx);			//	ť Ž ġ 

	//	ť   ݺ
	while (QueueIsEmpty(&q) == NO)
	{
		int IsPalindrome = YES;		//	Ž  ڿ ȸ Ǵϴ  
		int curPalindromeLen = 0;	//	Ž  ڿ ȭ 쿡  ڿ 
		int i;

		searchIdx = Front(&q);		//	ť Ž ε  
		Pop(&q);					//	ť 

		int startSearchIdx = searchIdx.startIdx;
		int endSearchIdx = searchIdx.endIdx;

		//	Ž  ε  ε   Ǹ  Ž . 
		if (startSearchIdx > endSearchIdx)				continue;

		//	ŽϷ ġ  Ǿ ִٸ ̹ Ž Ϸ ǾǷ,
		//	Ž  ʿ䰡 .
		if (g_DT[startSearchIdx][endSearchIdx] == YES)	continue;

		g_DT[startSearchIdx][endSearchIdx] = YES;	//	Ž  ʾ Ž ϰ Ž .

		//	pStr迭 startSearchIdx endSearchIdx Žؼ Ž  ȸ üũѴ.
		for (i = 0; i < endSearchIdx - startSearchIdx + 1; i++)
		{
			//	ȸ   ʴ 
			if (pStr[i + startSearchIdx] != pStr[endSearchIdx - i])
			{
				IsPalindrome = NO;
				break;
			}
			curPalindromeLen++;
		}

		//	startSearchIdx endSearchIdx  ȸ̸, 
		//	  ڿ ̸   g_pPalindromStr迭 g_maxPalindromStrLen Ѵ.
		if (IsPalindrome == YES)
		{
			//	 ãƳ ȸ ̿   ãƳ ȸ ̸ ؼ
			//	 ãƳ ȸ ̰ ٸ  ȸ ڿ ̸  Ѵ.
			if (curPalindromeLen > g_maxPalindromStrLen)
			{
				g_maxPalindromStrLen = curPalindromeLen;

				for (i = 0; i < endSearchIdx - startSearchIdx + 1; i++)
					g_pPalindromStr[i] = pStr[i + startSearchIdx];

				//	 ڸ   
				g_pPalindromStr[i] = '\0';
			}
		}

		//	 Ž ε ť  
		Index nextSearchIdx = { startSearchIdx + 1, endSearchIdx };
		Push(&q, nextSearchIdx);

		//	 Ž ε ť  
		nextSearchIdx.startIdx = startSearchIdx;
		nextSearchIdx.endIdx = endSearchIdx - 1;

		Push(&q, nextSearchIdx);
	}
}


